diff -Naurd cluster-3.0.0.rc2/cman/cman_tool/join.c cluster-3.0.0.rc3/cman/cman_tool/join.c
--- cluster-3.0.0.rc2/cman/cman_tool/join.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/cman_tool/join.c	2009-06-11 11:02:55.000000000 +0200
@@ -172,12 +172,12 @@
 	if (comline->noconfig_opt) {
 		envp[envptr++] = strdup("CMAN_NOCONFIG=true");
 		snprintf(scratch, sizeof(scratch), "COROSYNC_DEFAULT_CONFIG_IFACE=cmanpreconfig%s",
-			 comline->noopenais_opt?"":":openaisserviceenable");
+			 comline->noopenais_opt?"":":openaisserviceenablestable");
 		envp[envptr++] = strdup(scratch);
 	}
 	else {
 		snprintf(scratch, sizeof(scratch), "COROSYNC_DEFAULT_CONFIG_IFACE=%s:cmanpreconfig%s", comline->config_lcrso,
-			 comline->noopenais_opt?"":":openaisserviceenable");
+			 comline->noopenais_opt?"":":openaisserviceenablestable");
 		envp[envptr++] = strdup(scratch);
 	}
 
diff -Naurd cluster-3.0.0.rc2/cman/cman_tool/main.c cluster-3.0.0.rc3/cman/cman_tool/main.c
--- cluster-3.0.0.rc2/cman/cman_tool/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/cman_tool/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -53,8 +53,8 @@
 		printf("  -w               Wait until node has joined a cluster\n");
 		printf("  -q               Wait until the cluster is quorate\n");
 		printf("  -t               Maximum time (in seconds) to wait\n");
-		printf("  -k <file>        Private key file for AIS communications\n");
-		printf("  -P               Don't set aisexec to realtime priority\n");
+		printf("  -k <file>        Private key file for Corosync communications\n");
+		printf("  -P               Don't set corosync to realtime priority\n");
 		printf("  -X               Use internal cman defaults for configuration\n");
 		printf("  -A               Don't load openais services\n");
 		printf("\n");
diff -Naurd cluster-3.0.0.rc2/cman/daemon/ais.c cluster-3.0.0.rc3/cman/daemon/ais.c
--- cluster-3.0.0.rc2/cman/daemon/ais.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/ais.c	2009-06-11 11:02:55.000000000 +0200
@@ -31,7 +31,6 @@
 #include "cnxman-socket.h"
 #include "cnxman-private.h"
 #include "commands.h"
-#include "logging.h"
 
 #include "ais.h"
 #include "cman.h"
@@ -57,7 +56,6 @@
 static hdb_handle_t cluster_parent_handle;
 
 static int startup_pipe;
-static unsigned int debug_mask;
 static int first_trans = 1;
 struct corosync_api_v1 *corosync;
 
@@ -90,7 +88,7 @@
 			    const unsigned int *left_list, size_t left_list_entries,
 			    const unsigned int *joined_list, size_t joined_list_entries,
 			    const struct memb_ring_id *ring_id);
-static void cman_deliver_fn(unsigned int nodeid, const struct iovec *iovec, unsigned int iov_len,
+static void cman_deliver_fn(unsigned int nodeid, const void *msg, unsigned int msg_len,
 			    int endian_conversion_required);
 static void cman_quorum_init(struct corosync_api_v1 *api, quorum_set_quorate_fn_t report);
 
@@ -185,13 +183,10 @@
 		objdb_get_int(api, object_handle, "quorum_dev_poll", &quorumdev_poll, DEFAULT_QUORUMDEV_POLL);
 		objdb_get_int(api, object_handle, "shutdown_timeout", &shutdown_timeout, DEFAULT_SHUTDOWN_TIMEOUT);
 		objdb_get_int(api, object_handle, "ccsd_poll", &ccsd_poll_interval, DEFAULT_CCSD_POLL);
-		objdb_get_int(api, object_handle, "debug_mask", &debug_mask, 0);
 
-		/* All other debugging options should already have been set in preconfig */
-		set_debuglog(debug_mask);
 	}
 	corosync->object_find_destroy(find_handle);
-	P_DAEMON(CMAN_NAME " starting");
+	log_printf(LOGSYS_LEVEL_DEBUG, CMAN_NAME " starting");
 
 	/* Open local sockets and initialise I/O queues */
 	if (read_cman_config(api, &config_version)) {
@@ -231,7 +226,7 @@
 	struct cl_protheader header;
 	int totem_flags = TOTEM_AGREED;
 
-	P_AIS("comms send message %p len = %d\n", buf,len);
+	log_printf(LOGSYS_LEVEL_DEBUG, "ais: comms send message %p len = %d\n", buf,len);
 	header.tgtport = toport;
 	header.srcport = fromport;
 	header.flags   = flags;
@@ -249,28 +244,31 @@
 	return corosync->tpg_joined_mcast(group_handle, iov, 2, totem_flags);
 }
 
-// This assumes the iovec has only one element ... is it true ??
-static void cman_deliver_fn(unsigned int nodeid, const struct iovec *iovec, unsigned int iov_len,
+static void cman_deliver_fn(unsigned int nodeid, const void *msg, unsigned int msg_len,
 			    int endian_conversion_required)
 {
-	struct cl_protheader *header = iovec->iov_base;
-	char *buf = iovec->iov_base;
+	const struct cl_protheader *original_header = msg;
+	struct cl_protheader header;
+	const char *buf = msg;
 
-	P_AIS("deliver_fn source nodeid = %d, len=%d, endian_conv=%d\n",
-	      nodeid, (int)iovec->iov_len, endian_conversion_required);
+	log_printf(LOGSYS_LEVEL_DEBUG, "ais: deliver_fn source nodeid = %d, len=%d, endian_conv=%d\n",
+	      nodeid, msg_len, endian_conversion_required);
 
 	if (endian_conversion_required) {
-		header->srcid = swab32(header->srcid);
-		header->tgtid = swab32(header->tgtid);
-		header->flags = swab32(header->flags);
+		header.srcid = swab32(original_header->srcid);
+		header.tgtid = swab32(original_header->tgtid);
+		header.flags = swab32(original_header->flags);
+	} 
+	else {
+	        memcpy(&header, original_header, sizeof(header));
 	}
 
 	/* Only pass on messages for us or everyone */
-	if (header->tgtid == our_nodeid() ||
-	    header->tgtid == 0) {
-		send_to_userport(header->srcport, header->tgtport,
-				 header->srcid, header->tgtid,
-				 buf + sizeof(struct cl_protheader), iovec->iov_len - sizeof(struct cl_protheader),
+	if (header.tgtid == our_nodeid() ||
+	    header.tgtid == 0) {
+		send_to_userport(header.srcport, header.tgtport,
+				 header.srcid, header.tgtid,
+				 buf + sizeof(struct cl_protheader), msg_len - sizeof(struct cl_protheader),
 				 endian_conversion_required);
 	}
 }
@@ -287,7 +285,7 @@
 	static size_t saved_left_list_size;
 	static unsigned int *saved_left_list = NULL;
 
-	P_AIS("confchg_fn called type = %d, seq=%lld\n", configuration_type, ring_id->seq);
+	log_printf(LOGSYS_LEVEL_DEBUG, "ais: confchg_fn called type = %d, seq=%lld\n", configuration_type, ring_id->seq);
 
 	memcpy(&cman_ring_id, ring_id, sizeof(*ring_id));
 	incarnation = ring_id->seq;
@@ -324,7 +322,7 @@
 	}
 
 	if (configuration_type == TOTEM_CONFIGURATION_REGULAR) {
-		P_AIS("last memb_count = %d, current = %"PRIuFAST32"\n", last_memb_count, member_list_entries);
+		log_printf(LOGSYS_LEVEL_DEBUG, "ais: last memb_count = %d, current = %"PRIuFAST32"\n", last_memb_count, member_list_entries);
 		send_transition_msg(last_memb_count, first_trans);
 		last_memb_count = member_list_entries;
 		if (member_list_entries > 1)
@@ -336,6 +334,11 @@
 	}
 }
 
+void corosync_shutdown(void)
+{
+	corosync->request_shutdown();
+}
+
 /* Write an error message down the CMAN startup pipe so
    that cman_tool can display it */
 int write_cman_pipe(const char *message)
diff -Naurd cluster-3.0.0.rc2/cman/daemon/ais.h cluster-3.0.0.rc3/cman/daemon/ais.h
--- cluster-3.0.0.rc2/cman/daemon/ais.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/ais.h	2009-06-11 11:02:55.000000000 +0200
@@ -11,3 +11,4 @@
 extern int num_ais_nodes;
 extern quorum_set_quorate_fn_t corosync_set_quorum;
 extern struct memb_ring_id cman_ring_id;
+extern void corosync_shutdown(void);
diff -Naurd cluster-3.0.0.rc2/cman/daemon/barrier.c cluster-3.0.0.rc3/cman/daemon/barrier.c
--- cluster-3.0.0.rc2/cman/daemon/barrier.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/barrier.c	2009-06-11 11:02:55.000000000 +0200
@@ -28,7 +28,6 @@
 #include "cnxman-private.h"
 #include "daemon.h"
 #include "commands.h"
-#include "logging.h"
 #include "barrier.h"
 #include "cman.h"
 #include "ais.h"
@@ -104,7 +103,7 @@
 		bmsg.subcmd = BARRIER_COMPLETE;
 		strcpy(bmsg.name, barrier->name);
 
-		P_BARRIER("Sending COMPLETE for %s\n", barrier->name);
+		log_printf(LOGSYS_LEVEL_DEBUG, "barrier: Sending COMPLETE for %s\n", barrier->name);
 		comms_send_message((char *) &bmsg, sizeof (bmsg),
 				   0, 0,
 				   0,
@@ -116,7 +115,7 @@
 /* Return 1 if we deleted the barrier */
 static int barrier_complete_phase2(struct cl_barrier *barrier, int status)
 {
-	P_BARRIER("complete_phase2 for %s\n", barrier->name);
+	log_printf(LOGSYS_LEVEL_DEBUG, "barrier: complete_phase2 for %s\n", barrier->name);
 
 	barrier->endreason = status;
 
@@ -141,7 +140,7 @@
 {
 	struct cl_barrier *barrier = arg;
 
-	P_BARRIER("Barrier timer_fn called for %s\n", barrier->name);
+	log_printf(LOGSYS_LEVEL_DEBUG, "barrier: Barrier timer_fn called for %s\n", barrier->name);
 
 	/* Ignore any futher messages, they are too late. */
 	barrier->phase = 0;
@@ -186,7 +185,7 @@
 	if (!barrier)
 		return;
 
-	P_BARRIER("Got %d for %s, from node %s\n", msg->subcmd, msg->name,
+	log_printf(LOGSYS_LEVEL_DEBUG, "barrier: Got %d for %s, from node %s\n", msg->subcmd, msg->name,
 		  node ? node->name : "unknown");
 
 	switch (msg->subcmd) {
@@ -228,7 +227,7 @@
 	if (flags & BARRIER_ATTR_MULTISTEP)
 		return -EINVAL;
 
-	P_BARRIER("barrier_register %s, nodes = %d, flags =%x\n", name, nodes, flags);
+	log_printf(LOGSYS_LEVEL_DEBUG, "barrier: barrier_register %s, nodes = %d, flags =%x\n", name, nodes, flags);
 
 	/* See if it already exists */
 	if ((barrier = find_barrier(name))) {
@@ -282,7 +281,7 @@
 						   barrier_timer_fn, &barrier->timer);
 		}
 
-		P_BARRIER("Sending WAIT for %s\n", barrier->name);
+		log_printf(LOGSYS_LEVEL_DEBUG, "barrier: Sending WAIT for %s\n", barrier->name);
 		status = comms_send_message((char *)&bmsg, sizeof(bmsg), 0,0, 0, MSG_TOTEM_SAFE);
 		if (status < 0) {
 			return status;
diff -Naurd cluster-3.0.0.rc2/cman/daemon/cmanconfig.c cluster-3.0.0.rc3/cman/daemon/cmanconfig.c
--- cluster-3.0.0.rc2/cman/daemon/cmanconfig.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/cmanconfig.c	2009-06-11 11:02:55.000000000 +0200
@@ -18,7 +18,6 @@
 #include "list.h"
 #include "cnxman-socket.h"
 #include "cnxman-private.h"
-#include "logging.h"
 #include "commands.h"
 #include "cman.h"
 #define OBJDB_API struct corosync_api_v1
@@ -100,7 +99,7 @@
 		    goto out_err;
 	    }
 
-	    P_MEMB("Got node %s from ccs (id=%d, votes=%d)\n", nodename, this_nodeid, votes);
+	    log_printf(LOGSYS_LEVEL_DEBUG, "memb: Got node %s from ccs (id=%d, votes=%d)\n", nodename, this_nodeid, votes);
 	    add_ccs_node(nodename, this_nodeid, votes, expected);
 	    nodes_handle = nodeslist_next(corosync, find_handle);
     } while (nodes_handle);
diff -Naurd cluster-3.0.0.rc2/cman/daemon/cman-preconfig.c cluster-3.0.0.rc3/cman/daemon/cman-preconfig.c
--- cluster-3.0.0.rc2/cman/daemon/cman-preconfig.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/cman-preconfig.c	2009-06-11 11:02:55.000000000 +0200
@@ -24,11 +24,10 @@
 #define OBJDB_API struct objdb_iface_ver0
 #include "cnxman-socket.h"
 #include "nodelist.h"
-#include "logging.h"
 
 #define MAX_PATH_LEN PATH_MAX
 
-static unsigned int debug_mask;
+static unsigned int debug;
 static int cmanpre_readconfig(struct objdb_iface_ver0 *objdb, const char **error_string);
 static int cmanpre_reloadconfig(struct objdb_iface_ver0 *objdb, int flush, const char **error_string);
 
@@ -203,30 +202,22 @@
 	char *str;
 
 	objdb->object_find_create(object_handle, "logger_subsys", strlen("logger_subsys"), &find_handle);
-	while (!objdb->object_find_next(object_handle, &subsys_handle)) {
-
-		if (objdb_get_string(objdb, subsys_handle, "subsys", &str)) {
-			continue;
+	while (!objdb->object_find_next(find_handle, &subsys_handle)) {
+		if (!objdb_get_string(objdb, subsys_handle, "subsys", &str)) {
+			if (strncmp(str, CMAN_NAME, 4) == 0) {
+				objdb->object_find_destroy(find_handle);
+				return subsys_handle;
+			}
 		}
-		if (strcmp(str, CMAN_NAME) == 0)
-			return subsys_handle;
 	}
 	objdb->object_find_destroy(find_handle);
 
-	/* We can't find it ... create one */
-	if (objdb->object_create(object_handle, &subsys_handle,
-				    "logger_subsys", strlen("logger_subsys")) == 0) {
-
-		objdb->object_key_create(subsys_handle, "subsys", strlen("subsys"),
-					    CMAN_NAME, strlen(CMAN_NAME)+1);
-	}
-
-	return subsys_handle;
+	return -1;
 
 }
 
 
-static int add_ifaddr(struct objdb_iface_ver0 *objdb, char *mcast, char *ifaddr, int port)
+static int add_ifaddr(struct objdb_iface_ver0 *objdb, char *mcast, char *ifaddr, int port, int broadcast)
 {
 	hdb_handle_t totem_object_handle;
 	hdb_handle_t find_handle;
@@ -275,8 +266,12 @@
 		objdb->object_key_create(interface_object_handle, "bindnetaddr", strlen("bindnetaddr"),
 					 tmp, strlen(tmp)+1);
 
-		objdb->object_key_create(interface_object_handle, "mcastaddr", strlen("mcastaddr"),
-					 mcast, strlen(mcast)+1);
+		if (broadcast)
+			objdb->object_key_create(interface_object_handle, "broadcast", strlen("broadcast"),
+						 "yes", strlen("yes")+1);
+		else
+			objdb->object_key_create(interface_object_handle, "mcastaddr", strlen("mcastaddr"),
+						 mcast, strlen(mcast)+1);
 
 		sprintf(tmp, "%d", port);
 		objdb->object_key_create(interface_object_handle, "mcastport", strlen("mcastport"),
@@ -503,7 +498,9 @@
 		votes = 1;
 	}
 	if (getenv("CMAN_DEBUG")) {
-		debug_mask = atoi(getenv("CMAN_DEBUG"));
+		debug = atoi(getenv("CMAN_DEBUG"));
+		if (debug > 0)
+			debug = 1;
 	}
 
 	return 0;
@@ -517,6 +514,8 @@
 	hdb_handle_t find_handle;
 	hdb_handle_t node_object_handle;
 	hdb_handle_t alt_object;
+	int broadcast = 0;
+	char *str;
 	int error;
 
 	if (!getenv("CMAN_NOCONFIG")) {
@@ -609,7 +608,18 @@
 		objdb_get_int(objdb, object_handle, "port", &portnum, DEFAULT_PORT);
 	}
 
-	if (add_ifaddr(objdb, mcast_name, nodename, portnum))
+	/* Check for broadcast */
+	if (!objdb_get_string(objdb, object_handle, "broadcast", &str)) {
+		if (strcmp(str, "yes") == 0) {
+			mcast_name = strdup("255.255.255.255");
+			if (!mcast_name)
+				return -1;
+			broadcast = 1;
+		}
+		free(str);
+	}
+
+	if (add_ifaddr(objdb, mcast_name, nodename, portnum, broadcast))
 		return -1;
 
 	/* Get all alternative node names */
@@ -630,7 +640,7 @@
 			mcast = mcast_name;
 		}
 
-		if (add_ifaddr(objdb, mcast, node, portnum))
+		if (add_ifaddr(objdb, mcast, node, portnum, broadcast))
 			return -1;
 
 		num_nodenames++;
@@ -644,9 +654,9 @@
 /* These are basically cman overrides to the totem config bits */
 static void add_cman_overrides(struct objdb_iface_ver0 *objdb)
 {
-	hdb_handle_t logger_object_handle;
 	char *logstr;
 	char *logfacility;
+	char *loglevel;
 	hdb_handle_t object_handle;
 	hdb_handle_t find_handle;
 	char tmp[256];
@@ -745,16 +755,17 @@
 	objdb->object_find_destroy(find_handle);
 
 	logfacility = facility_name_get(SYSLOGFACILITY);
+	loglevel = priority_name_get(SYSLOGLEVEL);
 
-	logger_object_handle = find_cman_logger(objdb, object_handle);
-
-	if (objdb_get_string(objdb, object_handle, "syslog_facility", &logstr)) {
-		objdb->object_key_create(object_handle, "syslog_facility", strlen("syslog_facility"),
-					    logfacility, strlen(logfacility)+1);
+	/* enable timestamps on logging */
+	if (objdb_get_string(objdb, object_handle, "timestamp", &logstr)) {
+		objdb->object_key_create(object_handle, "timestamp", strlen("timestamp"),
+					    "on", strlen("on")+1);
 	}
 
-	if (objdb_get_string(objdb, object_handle, "to_file", &logstr)) {
-		objdb->object_key_create(object_handle, "to_file", strlen("to_file"),
+	/* configure logfile */
+	if (objdb_get_string(objdb, object_handle, "to_logfile", &logstr)) {
+		objdb->object_key_create(object_handle, "to_logfile", strlen("to_logfile"),
 					    "yes", strlen("yes")+1);
 	}
 
@@ -763,27 +774,53 @@
 					    LOGDIR "/corosync.log", strlen(LOGDIR "/corosync.log")+1);
 	}
 
-	if (objdb_get_string(objdb, object_handle, "timestamp", &logstr)) {
-		objdb->object_key_create(object_handle, "timestamp", strlen("timestamp"),
-					    "on", strlen("on")+1);
+	if (objdb_get_string(objdb, object_handle, "logfile_priority", &logstr)) {
+		objdb->object_key_create(object_handle, "logfile_priority", strlen("logfile_priority"),
+					    loglevel, strlen(loglevel)+1);
 	}
 
-	if (debug_mask) {
-		objdb->object_key_create(object_handle, "to_stderr", strlen("to_stderr"),
+	/* syslog */
+	if (objdb_get_string(objdb, object_handle, "to_syslog", &logstr)) {
+		objdb->object_key_create(object_handle, "to_syslog", strlen("to_syslog"),
 					    "yes", strlen("yes")+1);
-		objdb->object_key_create(logger_object_handle, "debug", strlen("debug"),
-					    "on", strlen("on")+1);
-		objdb->object_key_create(logger_object_handle, "syslog_level", strlen("syslog_level"),
-					    "debug", strlen("debug")+1);
+	}
 
+	if (objdb_get_string(objdb, object_handle, "syslog_facility", &logstr)) {
+		objdb->object_key_create(object_handle, "syslog_facility", strlen("syslog_facility"),
+					    logfacility, strlen(logfacility)+1);
 	}
-	else {
-		char *loglevel;
-		loglevel = priority_name_get(SYSLOGLEVEL);
-		objdb->object_key_create(logger_object_handle, "syslog_level", strlen("syslog_level"),
+
+	if (objdb_get_string(objdb, object_handle, "syslog_priority", &logstr)) {
+		objdb->object_key_create(object_handle, "syslog_priority", strlen("syslog_priority"),
 					    loglevel, strlen(loglevel)+1);
 	}
 
+	if (!debug) {
+		hdb_handle_t logger_object_handle;
+
+		if (!objdb_get_string(objdb, object_handle, "debug", &logstr)) {
+			if (!strncmp(logstr, "on", 2)) {
+				debug=1;
+			}
+		}
+
+		logger_object_handle = find_cman_logger(objdb, object_handle);
+		if (logger_object_handle > -1) {
+			if (!objdb_get_string(objdb, logger_object_handle, "debug", &logstr)) {
+				if (!strncmp(logstr, "on", 2)) {
+					debug=1;
+				}
+				if (!strncmp(logstr, "off", 3)) {
+					debug=0;
+				}
+			}
+		}
+	}
+
+	if (debug) {
+		objdb->object_key_create(object_handle, "to_stderr", strlen("to_stderr"),
+					    "yes", strlen("yes")+1);
+	}
 
 	/* Make sure we allow connections from user/group "ais" */
 	objdb->object_find_create(OBJECT_PARENT_HANDLE, "aisexec", strlen("aisexec"), &find_handle);
@@ -812,11 +849,6 @@
 			objdb->object_key_create(object_handle, "two_node", strlen("two_node"),
 						 str, strlen(str) + 1);
 		}
-		if (debug_mask) {
-			sprintf(str, "%d", debug_mask);
-			objdb->object_key_create(object_handle, "debug_mask", strlen("debug_mask"),
-						 str, strlen(str) + 1);
-		}
 	}
 	objdb->object_find_destroy(find_handle);
 
